stages:
  - lint
  - test
  - bump_version
  - build
  - deploy

python_linter:
  stage: lint
  script:
    - make -i python-linter

test:
  stage: test
  image: python:3.9
  script:
    - pip install -r requirements-test.txt
    - pytest

bump_version:
  stage: bump_version
  image: python:3.9
  script:
    - pip install -r requirements-dev.txt
    - git config --global user.email "${GITLAB_USER_EMAIL}"
    - git config --global user.name "${GITLAB_USER_NAME}"
    - |
      if [[ "$CI_COMMIT_MESSAGE" == *"[major]"* ]]; then
        bumpversion major
      elif [[ "$CI_COMMIT_MESSAGE" == *"[minor]"* ]]; then
        bumpversion minor
      elif [[ "$CI_COMMIT_MESSAGE" == *"[patch]"* ]]; then
        bumpversion patch
      fi
    - git remote set-url origin "https://gitlab-ci-token:${PROJECT_ACCESS_TOKEN}@gitlab.com/${CI_PROJECT_NAMESPACE}/${CI_PROJECT_NAME}.git"
    - git push -o ci.skip --tags origin HEAD:${CI_COMMIT_REF_NAME}
  rules:
    - if: '$CI_COMMIT_BRANCH == "main"'
      when: always
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: never

build_docker_example_app:
  image: docker:24.0.7-dind
  services:
    - docker:24.0.7-dind
  cache: []
  stage: build
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  before_script:
    - echo "$CI_REGISTRY_PASSWORD" | docker login "$CI_REGISTRY" -u "$CI_REGISTRY_USER" --password-stdin
  script:
    - REGISTRY="${CI_REGISTRY}/${CI_PROJECT_PATH}"
    - IMAGE="${REGISTRY}/example-app"
    - docker build -f example_app/Dockerfile -t "${IMAGE}:${CI_COMMIT_REF_SLUG}" -t "${IMAGE}:${CI_COMMIT_SHA}" .
    - docker push $IMAGE --all-tags

deploy:
  stage: deploy
  image: python:3.9
  script:
    - git pull origin main
    - pip install -r requirements-dev.txt
    - rm -rf dist
    - python setup.py sdist bdist_wheel
    - twine upload --repository-url "https://upload.pypi.org/legacy/" dist/* -u "__token__" -p $PYPI_PASSWORD
  rules:
    - if: '$CI_COMMIT_BRANCH == "main"'
      when: always
